#include "NetLoadModule.h"
#include "IBindStatusCallback.h"

NLMCallBack NLMStatusCallback;

#ifdef DOTRACE
char *ProgressStrings[] =
{
    "BINDSTATUS_FINDINGRESOURCE",
    "BINDSTATUS_CONNECTING",
    "BINDSTATUS_REDIRECTING",
    "BINDSTATUS_BEGINDOWNLOADDATA",
    "BINDSTATUS_DOWNLOADINGDATA",
    "BINDSTATUS_ENDDOWNLOADDATA",
    "BINDSTATUS_BEGINDOWNLOADCOMPONENTS",
    "BINDSTATUS_INSTALLINGCOMPONENTS",
    "BINDSTATUS_ENDDOWNLOADCOMPONENTS",
    "BINDSTATUS_USINGCACHEDCOPY",
    "BINDSTATUS_SENDINGREQUEST",
    "BINDSTATUS_CLASSIDAVAILABLE",
    "BINDSTATUS_MIMETYPEAVAILABLE",
    "BINDSTATUS_CACHEFILENAMEAVAILABLE",
    "BINDSTATUS_BEGINSYNCOPERATION",
    "BINDSTATUS_ENDSYNCOPERATION",
    "BINDSTATUS_BEGINUPLOADDATA",
    "BINDSTATUS_UPLOADINGDATA",
    "BINDSTATUS_ENDUPLOADINGDATA",
    "BINDSTATUS_PROTOCOLCLASSID",
    "BINDSTATUS_ENCODING",
    "BINDSTATUS_VERFIEDMIMETYPEAVAILABLE",
    "BINDSTATUS_CLASSINSTALLLOCATION",
    "BINDSTATUS_DECODING",
    "BINDSTATUS_LOADINGMIMEHANDLER",
    "BINDSTATUS_CONTENTDISPOSITIONATTACH",
    "BINDSTATUS_FILTERREPORTMIMETYPE",
    "BINDSTATUS_CLSIDCANINSTANTIATE",
    "BINDSTATUS_IUNKNOWNAVAILABLE",
    "BINDSTATUS_DIRECTBIND",
    "BINDSTATUS_RAWMIMETYPE",
    "BINDSTATUS_PROXYDETECTING",
    "BINDSTATUS_ACCEPTRANGES"
};
#endif

HRESULT STDMETHODCALLTYPE NLMCallBack::OnProgress( 
	/* [in] */ ULONG ulProgress,
	/* [in] */ ULONG ulProgressMax,
	/* [in] */ ULONG ulStatusCode,
	/* [in] */ LPCWSTR szStatusText)
{
	HWND hCtrl = GetDlgItem(GlobalData.hMainDlg,IDC_PROGRESS1);

	while (ulProgressMax>65535L)
	{
		ulProgressMax/=1024;
		ulProgress/=1024;
	}

	SendMessage(hCtrl,PBM_SETRANGE,0,MAKELPARAM(0,ulProgressMax));
	SendMessage(hCtrl,PBM_SETPOS,(WPARAM)ulProgress,0);

#ifdef DOTRACE
	{
			char  sz[NLM_PATH_LENGTH];
			char  msg[NLM_PATH_LENGTH];

			// Build message. Requires bothersome Unicode conversions.
			//
			WideCharToMultiByte(CP_ACP, 0, szStatusText,-1, sz, NLM_PATH_LENGTH, 0,0);
			sprintf(msg,"Progress: %s %s %d of %d ",
				ProgressStrings[ulStatusCode], sz, ulProgress, ulProgressMax);

			TRACE(msg);
	}
#endif

	return S_OK;
}

